fallback = ((minetest.settings):get_bool("electricity_fallback") or false)
if not fallback then
  local ie = minetest.request_insecure_environment()
  if not ie then
    error(("Electricity mod requires access to insecure functions in order " .. "to work. Please add the electricity mod to your secure.trusted_mods.\n" .. "Insecure functions provide native (fast) complex numbers and arrays, " .. "which are necessary for MNA solver used in electricity mod.\n" .. "If you don\226\128\153t trust to Loria\226\128\153s developers or don\226\128\153t want to use electricity, " .. "you can enable fallback mode for electricity, " .. "in which Loria do not use these untrusted features, " .. "but this can SIGNIFICANTLY reduce performance if map has electronics.\n" .. "This can be done by inserting \226\128\156electricity_fallback = false\226\128\157 to your minetest.conf " .. "or in Minetest settings.\n\n" .. "BE CAREFUL: Loria exports `ffi.new` and `ffi.metatype` to global namespace, " .. "so they can be unsafely used by other mods."))
  end
  local ffi = ie.require("ffi")
  local function _2_(_cf_84, mt)
    return ffi.metatype(ffi.typeof(_cf_84), mt)
  end
  metatype = _2_
  isctype = ffi.istype
  allocate = ffi.new
end
return import("electricity", "complex", "matrix", "matrix-solve", "craftitems", "models", "functions", "sim", "globalstep", "ground", "switch", "battery", "transformer", "infinite", "consumer", "photoresistor", "riteg", "wires", "accumulator", "lamp", "multimeter", "relay", "amplifier")
