local function _1_(f, g)
  local function _2_(x)
    return f(g(x))
  end
  return _2_
end
comp = _1_
local function _3_(f, g)
  local function _4_(x)
    f(x)
    return g(x)
  end
  return _4_
end
andthen = _3_
local function _5_(f, l)
  local res = {}
  for key, val in pairs(l) do
    res[key] = f(val)
  end
  return res
end
map = _5_
local function _6_(f, l)
  local res = {}
  for key, val in ipairs(l) do
    res[key] = f(key, val)
  end
  return res
end
imap = _6_
local function _7_(f, l)
  for _, x in pairs(l) do
    f(x)
  end
  return nil
end
foreach = _7_
local function _8_(f, l)
  for id, x in ipairs(l) do
    f(id, x)
  end
  return nil
end
iforeach = _8_
local function _9_(f, l)
  for key, value in pairs(l) do
    f(key, value)
  end
  return nil
end
foreach2 = _9_
local function _10_(t_e2_82_80)
  local t = {}
  for k, v in pairs(t_e2_82_80) do
    t[k] = v
  end
  return t
end
copy = _10_
local function _11_(x)
  local function _12_(...)
    return x
  end
  return _12_
end
const = _11_
local function _13_(str, start)
  return (str:sub(1, #start) == start)
end
starts_with = _13_
local function _14_(str, ending)
  return ((ending == "") or (str:sub(( - #ending)) == ending))
end
ends_with = _14_
local function _15_(pos, name)
  local node = minetest.get_node(pos)
  if (node.name ~= name) then
    node["name"] = name
    return minetest.swap_node(pos, node)
  end
end
swap_node = _15_
local function _17_(inv, listname, stack, pos)
  local function add_or_drop0(stack0)
    if inv:room_for_item(listname, stack0) then
      return inv:add_item(listname, stack0)
    else
      return minetest.add_item(pos, stack0)
    end
  end
  local stack_e2_80_b2 = ItemStack(stack)
  local max = stack_e2_80_b2:get_stack_max()
  local amount = stack_e2_80_b2:get_count()
  local rem = (amount % max)
  local excess = math.floor((amount / max))
  stack_e2_80_b2:set_count(max)
  for i = 1, excess do
    add_or_drop0(stack_e2_80_b2)
  end
  stack_e2_80_b2:set_count(rem)
  return add_or_drop0(stack_e2_80_b2)
end
add_or_drop = _17_
local function _19_(dest, source)
  for _, x in ipairs(source) do
    table.insert(dest, x)
  end
  return nil
end
append = _19_
local function _20_(str)
  return string.gsub(str:gsub("^%l", string.upper), "_", " ")
end
capitalization = _20_
local function _21_(lst_e2_82_81, lst_e2_82_82)
  local res = {}
  for id, x in pairs(lst_e2_82_81) do
    res[id] = x
  end
  for id, y in pairs(lst_e2_82_82) do
    res[id] = y
  end
  return res
end
union = _21_
local function _22_(sep, ...)
  return table.concat({...}, sep)
end
join = _22_
i = vector.new(1, 0, 0)
j = vector.new(0, 0, 1)
k = vector.new(0, 1, 0)
local function _23_(pos)
  return vector.add(pos, k)
end
above = _23_
local function _24_(pos)
  return vector.subtract(pos, k)
end
under = _24_
local function _25_(mod, ...)
  local modpath = minetest.get_modpath(mod)
  local get_path
  local function _26_(name)
    return (modpath .. "/" .. name .. ".lua")
  end
  get_path = _26_
  return foreach(comp(dofile, get_path), {...})
end
import = _25_
local function gen_ordered_index(t)
  local ordered_index = {}
  for key, _ in pairs(t) do
    table.insert(ordered_index, key)
  end
  table.sort(ordered_index)
  return ordered_index
end
local function _27_(t, state)
  local key = nil
  if (state == nil) then
    t["ordered-index"] = gen_ordered_index(t)
    key = (t["ordered-index"])[1]
  else
    for i0 = 1, #t["ordered-index"] do
      if ((t["ordered-index"])[i0] == state) then
        key = (t["ordered-index"])[(i0 + 1)]
      end
    end
  end
  if key then
    return key, t[key]
  else
    t["ordered-index"] = nil
    return nil
  end
end
onext = _27_
local function _31_(t)
  return onext, t, nil
end
opairs = _31_
local function _32_(x, y)
  return (x + y)
end
plus = _32_
local function _33_(x, y)
  return (x - y)
end
minus = _33_
local function _34_(i_e2_82_98_e2_82_90_e2_82_93)
  local res = {}
  for i0 = 1, i_e2_82_98_e2_82_90_e2_82_93 do
    table.insert(res, i0)
  end
  return res
end
range = _34_
return nil
